require "yinx_sql/version"
require 'active_record'
require 'yinx'
require 'yinx_sql/batch'
require 'yinx_sql/json_batch'

module Yinx
  module SQL

    def self.connect *args
      ActiveRecord::Base.establish_connection *args
    end

    class Tables < ActiveRecord::Migration
      def up
        create_table :batches do |t|
          t.timestamps
        end

	create_table :tags do |t|
	  t.string :name
	  t.belongs_to :batch
	end

	create_table :notes do |t|
	  t.string :title
          t.string :book
          t.string :stack
	  t.integer :content_length
          t.timestamps
	  t.belongs_to :batch
	end

        create_table :notes_tags do |t|
          t.belongs_to :note, index: true
          t.belongs_to :tag, index: true
        end
      end

      def down
	[:notes_tags, :notes, :tags, :batches].each do |t|
	  drop_table t
	end
      end
    end

    class Json < ActiveRecord::Migration
      def up
        create_table :json_batches do |t|
          t.jsonb :batch, default: '[]'
        end
      end

      def down
        drop_table :json_batched
      end
    end

  end
end
